public class LetterFrequency {

    public static void main(String[] args) {
        String z = "SMPMMDPYRRYLMXMRCXYPMSMPMMDRYLMZMCXXKLYRNMZMDYPUMWPCSNWXMNYSXYPEWIWRIWPUMKYASMZMZMCXXKLYRNMZMDCLYARIYGMRNWPEWGHYZRCPRCLYARIYGMRNWPEZMCX";

        // Print letter frequencies:
        printLetterFrequencies(z);
    }

    public static void printLetterFrequencies( String txt ) {

        System.out.println("Letter\t\tFrequencies");

        // Loop through each letter
        for( char c = 'A'; c <= 'Z'; c++ ) {

            // Loop through each character in our string and count number of instances. Print results.
            int counter = 0; // declare counter outside loop

            for( int i=0; i<txt.length(); i++ ) {
                char c2 = txt.charAt(i);
                if(c==c2) { 
                    counter++;
                }
            }

            double frequency = (double)(counter)/(double)(txt.length());
            frequency *= 100;

            System.out.printf("%s\t\t%2.1f", c, frequency );
            System.out.println();
        }
    }
}
