public class Affine {
    private int key_a;
    private int key_b;

    public Affine(int key_a, int key_b) {
        this.key_a = key_a;
        this.key_b = key_b;

        if( gcd( this.key_a, 26 ) != 1 ) {
            throw new RuntimeException( "You must select the first portion a of your key (a,b) such that gcd(a,26)==1. You chose: "+key_a );
        }
    }

    public void setKeys(int key_a_new, int key_b_new) {
        this.key_a = key_a_new;
        this.key_b = key_b_new;

        if( gcd( this.key_a, 26 ) != 1 ) {
            throw new RuntimeException( "You must select the first portion a of your key (a,b) such that gcd(a,26)==1. You chose: "+key_a );
        }
    }

    public String encrypt(String message) {
        String message2 = "";

        message = message.toUpperCase();
        message = message.replace(" ","");
        message = message.replaceAll("['!-+.^:,]",""); 
        for( int j = 0; j < message.length(); j++ ) {
            char c, c2;
            int ix, ix2;
            c = message.charAt(j);
            ix = (int)(c - 'A');

            if( true ) {
                ix2 = (this.key_a * ix + this.key_b) % 26;
            } else {
                // decrypt
                // to decrypt, need a way to invert numbers modulo another number
                // e.g., 1/9 mod 26 = 3 mod 26, since 9 * 3 = 26
                // 26 / 9 = ?
                // have to to ensure everything positive, because -1 mod 26 does not become 25
                int z = 0;
            }

            c2 = (char)('A' + ix2);
            message2 += c2;
        }

        return message2;
    }

    /** Returns the greatest common denominator (GCD), 
     * computed using the Euclidian algorithm. */
    public static int gcd(int a, int b) {
        int small, big;
        int new_small, new_big;
        int remainder;
        int gcd;

        if(a > b) {
            big = a;
            small = b;
        } else {
            big = b;
            small = a;
        }

        while(true) {
            remainder = big % small;

            if(remainder==0) {
                gcd = small;
                break;
            }
            
            new_small = remainder;
            new_big = small;

            small = new_small;
            big = new_big;
        }        

        return gcd;

    }


}
