/**
 * Level 1 Puzzle 4:
 * This implements a Caesar cipher, then converts the letters 
 * to blocks of 8 numbers of the form 21-25-1-3-9-22-19-5.
 */
public class Puzzle4 {
    public static void main(String[] args) {
        puzzle4();
    }

    public static void puzzle4() {
        int k = 0;
        Caesar c = new Caesar(k);

        String encrypted, plain;



        System.out.println();

        c.setKey(13);
        plain = "A pangram is a sentence containing each letter of the alphabet at least once.";
        encrypted = c.encryptHard(plain);
        makeCaesarNumberPuzzle(plain,encrypted);

        c.setKey(13);
        plain = "If you have ever considered studying mathematics, now is the time. By the way the secret word is Einstein. Use that in puzzle quiz four.";
        encrypted = c.encryptHard(plain);
        makeCaesarNumberPuzzle(plain,encrypted);

        c.setKey(13);
        plain = "The word genius isn't applicable in football. A genius is a guy like Norman Einstein. Quarterback Joe Theisman.";
        encrypted = c.encryptHard(plain);
        makeCaesarNumberPuzzle(plain,encrypted);

    }


    public static void makeCaesarNumberPuzzle(String plain, String encrypted) {

        System.out.println("Plaintext:");
        System.out.println(plain);
        System.out.println();

        System.out.println("Cryptotoken (letters):");
        System.out.println(encrypted);
        System.out.println();


        System.out.println("Cryptotoken (numbers):");
        for( int i=0; i<encrypted.length(); i++ ) {
            char f = encrypted.charAt(i);
            int z = (int)( f - 'A' + 1 );

            // Print the numbers in rows of 8
            if(  ((i+1)%8==0) || (i==(encrypted.length()-1))  ) {
                System.out.println(z);
            } else {
                System.out.print(z + "-");
            }

        }
        System.out.println();

    }

}

