/**
 * Level 1 Puzzle 5:
 * This implements a Caesar cipher, then converts the letters 
 * to blocks of 8 numbers of the form 21-25-1-3-9-22-19-5.
 */
public class Puzzle5 {
    public static void main(String[] args) {
        puzzle5();
    }

    public static void puzzle5() {
        int k = 0;
        Caesar c = new Caesar(k);

        String encrypted, plain;

        System.out.println();

        c.setKey(10);
        plain = "Trust is the basis for all cryptosystems and for secrecy in communications. Trust requires mechanisms for verification. Secrecy does not exist in the absence of trust.";
        encrypted = c.encryptHard(plain);
        makeCaesarNumberPuzzle(plain,encrypted);

        c.setKey(14);
        plain = "We made too many wrong mistakes. Yogi Berra.";
        encrypted = c.encryptHard(plain);
        makeCaesarNumberPuzzle(plain,encrypted);

        c.setKey(22);
        plain = "Ronald Reagan once summarized good cryptography practice: trust but verify. Ronald Reagan was no cryptographer but you can access puzzle quiz five with the secret word raygun.";
        encrypted = c.encryptHard(plain);
        makeCaesarNumberPuzzle(plain,encrypted);

    }


    public static void makeCaesarNumberPuzzle(String plain, String encrypted) {

        System.out.println("Plaintext:");
        System.out.println(plain);
        System.out.println();

        System.out.println("Cryptotoken (letters):");
        System.out.println(encrypted);
        System.out.println();


        System.out.println("Cryptotoken (numbers):");
        System.out.println("(NOTHING TO SEE HERE, JUST DOING SOME ARITHMETIC)");
        for( int i=0; i<encrypted.length(); i++ ) {
            char f = encrypted.charAt(i);
            int z = (int)( f - 'A' + 1 );

            // Print the numbers in rows of 8
            if(  ((i+1)%4==0) || (i==(encrypted.length()-1))  ) {
                System.out.println(z);
            } else {
                System.out.print(z + "+");
            }

        }
        System.out.println();

    }





}



