import java.math.BigInteger;
import java.text.DecimalFormat;

public class Plugboard {
    public static void main(String[] args) { 
        DecimalFormat formatter = new DecimalFormat("#,###");

		BigInteger result;
		BigInteger num = new BigInteger("1");
		BigInteger denom = new BigInteger("2");

		
		int[] tryThese = {2,26,52,100,255};

		for(int S : tryThese) { 

			for(int N=1; N<=(S/2); N++) { 


				// S!/(S-2N)!
				num = BigInteger.valueOf(1);
				for(int i = S; i > (S-2*N); i--) { 
					BigInteger next = BigInteger.valueOf(i);
					num = num.multiply(next);
				}

				// divided by 2^N 
				denom = BigInteger.valueOf(2);
				denom = denom.pow(N);
				// divided by N! 
				for(int j = N; j>=1; j--) { 
					BigInteger next = BigInteger.valueOf(j);
					denom = denom.multiply(next);
				}

				result = num.divide(denom);

				System.out.printf("S = %d\t\tN = %d\t\tC = %s\n", S, N, formatter.format(result));

			}
		}

	}
}
