import java.util.*;
public class MoscowPuzzles {
    public static void main(String[] args) { 
        //problem340();
        //problem341();
        problem342();
    }



    public static void problem340() {

        // Part B
        long a = 123456789;
        long b = 987654321;
        System.out.println("Problem 340");
        for( int i=2; i<=9; i++ ) {

            System.out.println("------");
            System.out.println(i);
            System.out.println("ai: " + (a*i) );
            System.out.println("bi: " + (b*i) );

        }
        System.out.println();
    }



    public static void problem341() {

        int start = (int)(Math.ceil(Math.sqrt(1000)));
        int end = 99;
        for(int i=start; i<=end; i++) {
            int sq = i*i;
            int n1 = sq%100;
            int n2 = (int)(Math.floor(sq/100));
            int sum = (n1+n2)*(n1+n2);
            if(sum==sq) {
                System.out.println("This Square Equals Sum of Squares");
                System.out.println("Square = "+sq);
                System.out.println("Sum of Squares = ("+n1+" + "+n2+")^2 = "+sum);
                System.out.println();
            }
        }

    }



    public static void problem342() { 
        //problem342a();
        problem342b();
    }



    public static void problem342a() { 

        // Part A
        int Nd = 8;
        int Ns = 100;
        int[] n = new int[Nd];
        Random r = new Random();

        // Initialize
        for( int i = 0; i < Nd; i++ ) {
            n[i] = r.nextInt(9999);
        }
        System.out.println("Starting vector:");
        printArray(n);

        // Difference
        System.out.println("Difference vector:");
        int[] s = new int[Nd];
        for( int i = 0; i < Nd; i++ ) {
            s[i] = n[i];
        }
        for( int j = 0; j < Ns; j++ ) {
            for( int i=0; i < Nd; i++ ) {
                int i1 = (i+1)%Nd;
                int i2 = i;
                int d = s[i1] - s[i2];
                d = Math.abs(d);
                s[i] = d;
            }
        }
        printArray(s);
    }



    public static void problem342b() {
        //sumOfSquares();
        //sumOfCubes();
        sumOfQuadrics();
    }



    public static void sumOfSquares() {

        // Part B
        // Sum of Squares of Digits
        int Nterms = 30;

        Random r = new Random();
        int w = r.nextInt(999);

        System.out.print(w);
        for(int q=0; q<Nterms; q++ ) {
            if(w==89 || w==1) {
                break;
            }
            String ns = Integer.toString( w );
            w = 0;
            System.out.print(" = ");
            for(int i=0; i<ns.length(); i++) { 
                int z = Character.getNumericValue( ns.charAt(i) );
                System.out.print(z+"^2 ");
                if(i != ns.length() -1 ) {
                    System.out.print(" + ");
                }
                w += z*z;
            }
            System.out.print(" = ");
            System.out.print(w);
            System.out.print("\n");
        }
        System.out.println();

    }



    public static void sumOfCubes() {

        // Sum of Cubes of Digits
        int Nterms = 30;

        Random r = new Random();
        int w = r.nextInt(999);

        System.out.print(w);
        for(int q=0; q<Nterms; q++ ) {
            String ns = Integer.toString( w );
            w = 0;
            System.out.print(" = ");
            for(int i=0; i<ns.length(); i++) { 
                int z = Character.getNumericValue( ns.charAt(i) );
                System.out.print(z+"^3 ");
                if(i != ns.length() -1 ) {
                    System.out.print(" + ");
                }
                w += z*z*z;
            }
            System.out.print(" = ");
            System.out.print(w);
            System.out.print("\n");
        }
        System.out.println();

    }



    public static void sumOfQuadrics() {

        // Sum of Quadrics of Digits
        int Nterms = 100;

        Random r = new Random();
        int w = r.nextInt(999);

        System.out.print(w);
        for(int q=0; q<Nterms; q++ ) {
            if(w==13139 || w==8208 || w==2178) {
                break;
            }
            String ns = Integer.toString( w );
            w = 0;
            System.out.print(" = ");
            for(int i=0; i<ns.length(); i++) { 
                int z = Character.getNumericValue( ns.charAt(i) );
                System.out.print(z+"^4 ");
                if(i != ns.length() -1 ) {
                    System.out.print(" + ");
                }
                w += z*z*z*z;
            }
            System.out.print(" = ");
            System.out.print(w);
            System.out.print("\n");
        }
        System.out.println();

    }

    public static void printArray(int[] arr) {
        for(int i=0; i<arr.length; i++) {
            System.out.printf("%10d",arr[i]);
        }
        System.out.printf("\n");
    }


}

