/**
 * Level 1 Puzzle 6:
 * Implements an Affine cipher. 
 */
public class Puzzle6 {
    public static void main(String[] args) {
        puzzle6();
    }

    public static void puzzle6() {
        String encrypted, plain;
        Affine a = new Affine(9,1);

        // ---------

        a.setKeys(9,15);
        plain = "A prime number has no factors other than one and itself Large prime numbers are an important element of modern cryptography";
        encrypted = a.encrypt(plain);

        System.out.println("Plaintext:");
        System.out.println( plain );
        System.out.println();
        System.out.println("Cryptotoken:");
        System.out.println( encrypted );
        System.out.println();

        // ---------

        a.setKeys(3,6);
        plain = "In mathematics you don't understand things. You just get used to them. John Von Neumann";
        encrypted = a.encrypt(plain);

        System.out.println("Plaintext:");
        System.out.println( plain );
        System.out.println();
        System.out.println("Cryptotoken:");
        System.out.println( encrypted );
        System.out.println();

        // ---------

        a.setKeys(8,3);
        plain = "A number that is both a Fibonacci number and a prime number is a Fibonacci prime. The largest known Fibonacci prime has over six hundred thousand digits. Your secret key is Fibonacci.";
        encrypted = a.encrypt(plain);

        System.out.println("Plaintext:");
        System.out.println( plain );
        System.out.println();
        System.out.println("Cryptotoken:");
        System.out.println( encrypted );
        System.out.println();

    }
}

